package types

type DiscoveryMessageType int

const (
	DiscoveryMessageTypeNone DiscoveryMessageType = iota
	DiscoveryMessageTypeQueueing
	DiscoveryMessageTypeFailedQueueing
	DiscoveryMessageTypeTimeout
	DiscoveryMessageTypeStart
	DiscoveryMessageTypeStop
	DiscoveryMessageTypeError
	DiscoveryMessageTypeHost
	DiscoveryMessageTypePort
	DiscoveryMessageTypeService
)

type DiscoveryRequestType int

const (
	DiscoveryRequestTypeNone DiscoveryRequestType = iota
	DiscoveryRequestTypeHost
	DiscoveryRequestTypePort
	DiscoveryRequestTypeService
)

type DiscoveryMessage func() (request DiscoveryRequest, messageType DiscoveryMessageType, data interface{}, err error)

func MakeDiscoveryMessage(request DiscoveryRequest, messageType DiscoveryMessageType, data interface{}, err error) DiscoveryMessage {
	return func() (DiscoveryRequest, DiscoveryMessageType, interface{}, error) {
		return request, messageType, data, err
	}
}

type DiscoveryRequest interface {
	RequesterID() string
	RequestType() DiscoveryRequestType
	Params() []interface{}
}
